(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('rxjs'), require('calendarize'), require('wcag-contrast'), require('date-fns'), require('@angular/material/icon'), require('@angular/common'), require('@angular/material/button')) :
    typeof define === 'function' && define.amd ? define('ngb-material-datepicker', ['exports', '@angular/core', 'rxjs', 'calendarize', 'wcag-contrast', 'date-fns', '@angular/material/icon', '@angular/common', '@angular/material/button'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory(global['ngb-material-datepicker'] = {}, global.ng.core, global.rxjs, global.calendarize, global['wcag-contrast'], global['date-fns'], global.ng.material.icon, global.ng.common, global.ng.material.button));
}(this, (function (exports, i0, rxjs, calendarize, wcagContrast, dateFns, icon, common, button) { 'use strict';

    function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

    var calendarize__default = /*#__PURE__*/_interopDefaultLegacy(calendarize);

    var NgbMaterialDatepickerInjector = /** @class */ (function () {
        function NgbMaterialDatepickerInjector(_parentInjector, _additionalTokens) {
            this._parentInjector = _parentInjector;
            this._additionalTokens = _additionalTokens;
        }
        NgbMaterialDatepickerInjector.prototype.get = function (token, notFoundValue, flags) {
            var value = this._additionalTokens.get(token);
            if (value) {
                return value;
            }
            return this._parentInjector.get(token, notFoundValue);
        };
        return NgbMaterialDatepickerInjector;
    }());

    var NgbMaterialDatepickerConfig = /** @class */ (function () {
        function NgbMaterialDatepickerConfig() {
        }
        return NgbMaterialDatepickerConfig;
    }());

    var NgbMaterialDatepickerRef = /** @class */ (function () {
        function NgbMaterialDatepickerRef() {
            /**
             * 閉じた時に値を渡すためのSubject
             * @private
             */
            this._afterClose = new rxjs.Subject();
            /**
             * 閉じた時の値を受け取るためのObservable
             */
            this.afterClose = this._afterClose.asObservable();
        }
        /**
         * Datepickerを閉じる。
         * @param result
         */
        NgbMaterialDatepickerRef.prototype.close = function (result) {
            this._afterClose.next(result);
        };
        return NgbMaterialDatepickerRef;
    }());

    var DynamicallyComponentService = /** @class */ (function () {
        function DynamicallyComponentService(componentFactoryResolver, applicationRef, injector) {
            this.componentFactoryResolver = componentFactoryResolver;
            this.applicationRef = applicationRef;
            this.injector = injector;
        }
        Object.defineProperty(DynamicallyComponentService.prototype, "dynamicComponentRef", {
            get: function () {
                if (!this._dynamicComponentRef) {
                    throw new Error('Component has not been created');
                }
                return this._dynamicComponentRef;
            },
            enumerable: false,
            configurable: true
        });
        /**
         * 動的コンポーネントをdocument.body配下に追加する。
         */
        DynamicallyComponentService.prototype.appendToApplication = function (type, config) {
            var _this = this;
            var datepickerRef = new NgbMaterialDatepickerRef();
            var componentRef = this.createComponentRef(type, config, datepickerRef);
            this.applicationRef.attachView(componentRef.hostView);
            this._attachComponentToDocumentBody(componentRef);
            this._dynamicComponentRef = componentRef;
            // 様々な箇所で呼ばれるDatepickerRef.afterCloseを検知し、Datepickerを閉じて購読を解除する。
            var sub = datepickerRef.afterClose.subscribe(function () {
                _this._removeFromApplication();
                sub.unsubscribe();
            });
            return datepickerRef;
        };
        /**
         * 動的コンポーネントをdocument.bodyから削除する。
         * @private
         */
        DynamicallyComponentService.prototype._removeFromApplication = function () {
            if (!this._dynamicComponentRef) {
                throw new Error('Component has not been created');
            }
            this.applicationRef.detachView(this._dynamicComponentRef.hostView);
            this._dynamicComponentRef.destroy();
        };
        /**
         * ComponentRefを作成する。
         * @param componentType
         * @param config
         * @param datepickerRef
         * @private
         * @return {ComponentRef}
         */
        DynamicallyComponentService.prototype.createComponentRef = function (componentType, config, datepickerRef) {
            var map = new WeakMap();
            map.set(NgbMaterialDatepickerConfig, config);
            map.set(NgbMaterialDatepickerRef, datepickerRef);
            var componentFactory = this.componentFactoryResolver.resolveComponentFactory(componentType);
            return componentFactory.create(new NgbMaterialDatepickerInjector(this.injector, map));
        };
        /**
         * ComponentRefをdocument.body配下に追加する。
         * @param componentRef
         * @private
         * @return {void}
         */
        DynamicallyComponentService.prototype._attachComponentToDocumentBody = function (componentRef) {
            var domElm = componentRef.hostView.rootNodes[0];
            document.body.appendChild(domElm);
        };
        return DynamicallyComponentService;
    }());
    DynamicallyComponentService.ɵprov = i0.ɵɵdefineInjectable({ factory: function DynamicallyComponentService_Factory() { return new DynamicallyComponentService(i0.ɵɵinject(i0.ComponentFactoryResolver), i0.ɵɵinject(i0.ApplicationRef), i0.ɵɵinject(i0.INJECTOR)); }, token: DynamicallyComponentService, providedIn: "root" });
    DynamicallyComponentService.decorators = [
        { type: i0.Injectable, args: [{
                    providedIn: 'root',
                },] }
    ];
    DynamicallyComponentService.ctorParameters = function () { return [
        { type: i0.ComponentFactoryResolver },
        { type: i0.ApplicationRef },
        { type: i0.Injector }
    ]; };

    var NgbMaterialDatepickerOverlayComponent = /** @class */ (function () {
        function NgbMaterialDatepickerOverlayComponent(_dynamicallyComponent, _datepickerRef) {
            this._dynamicallyComponent = _dynamicallyComponent;
            this._datepickerRef = _datepickerRef;
        }
        NgbMaterialDatepickerOverlayComponent.prototype.ngAfterViewInit = function () { };
        NgbMaterialDatepickerOverlayComponent.prototype.ngOnDestroy = function () { };
        /**
         * Overlayがクリックされた。
         * @param {MouseEvent} event
         */
        NgbMaterialDatepickerOverlayComponent.prototype.onOverlayClick = function (event) {
            this._datepickerRef.close();
        };
        /**
         * ダイアログがクリックされた。
         * ※ダイアログクリックでもOverlayのクリック扱いとなってしまうため、イベントを止める。
         * @param {MouseEvent} event
         */
        NgbMaterialDatepickerOverlayComponent.prototype.onDialogClick = function (event) {
            event.stopPropagation();
        };
        return NgbMaterialDatepickerOverlayComponent;
    }());
    NgbMaterialDatepickerOverlayComponent.decorators = [
        { type: i0.Component, args: [{
                    selector: 'lib-ngb-material-datepicker-container',
                    template: "<div class=\"overlay\" (click)=\"onOverlayClick($event)\">\n    <div class=\"dialog\" (click)=\"onDialogClick($event)\">\n        <lib-ngb-material-datepicker></lib-ngb-material-datepicker>\n    </div>\n</div>\n",
                    styles: [".overlay{position:fixed;top:0;bottom:0;left:0;right:0;background:rgba(0,0,0,.7);align-items:center;justify-content:center}.dialog,.overlay{display:flex;flex-direction:column}.dialog{background-color:#fff;width:300px;height:520px}"]
                },] }
    ];
    NgbMaterialDatepickerOverlayComponent.ctorParameters = function () { return [
        { type: DynamicallyComponentService },
        { type: NgbMaterialDatepickerRef }
    ]; };

    var NgbMaterialDatepickerService = /** @class */ (function () {
        function NgbMaterialDatepickerService(_dynamicallyComponent) {
            this._dynamicallyComponent = _dynamicallyComponent;
        }
        /**
         * Datepickerを開く。
         */
        NgbMaterialDatepickerService.prototype.open = function (config) {
            return this._dynamicallyComponent.appendToApplication(NgbMaterialDatepickerOverlayComponent, config);
        };
        return NgbMaterialDatepickerService;
    }());
    NgbMaterialDatepickerService.ɵprov = i0.ɵɵdefineInjectable({ factory: function NgbMaterialDatepickerService_Factory() { return new NgbMaterialDatepickerService(i0.ɵɵinject(DynamicallyComponentService)); }, token: NgbMaterialDatepickerService, providedIn: "root" });
    NgbMaterialDatepickerService.decorators = [
        { type: i0.Injectable, args: [{
                    providedIn: 'root',
                },] }
    ];
    NgbMaterialDatepickerService.ctorParameters = function () { return [
        { type: DynamicallyComponentService }
    ]; };

    var DateTableService = /** @class */ (function () {
        function DateTableService() {
        }
        /**
         * DateTableを作成する。
         * @param {undefined|Date} date
         * @return {DateTable}
         */
        DateTableService.prototype.create = function (date) {
            if (date == null) {
                return calendarize__default['default'](new Date());
            }
            return calendarize__default['default'](date);
        };
        return DateTableService;
    }());
    DateTableService.ɵprov = i0.ɵɵdefineInjectable({ factory: function DateTableService_Factory() { return new DateTableService(); }, token: DateTableService, providedIn: "root" });
    DateTableService.decorators = [
        { type: i0.Injectable, args: [{
                    providedIn: 'root',
                },] }
    ];
    DateTableService.ctorParameters = function () { return []; };

    // @dynamic
    var A11yColor = /** @class */ (function () {
        function A11yColor() {
        }
        /**
         * 渡されたカラーコードの形式が正しいか判定する。
         * ※#FFFFFFの形式のみ有効。またカラーコードがundefined等のときの判定は、
         * 使用側によって変わるため、ここでは行わない。
         * @param colorCode
         */
        A11yColor.validColorCode = function (colorCode) {
            return this.COLOR_CODE_PATTERN.test(colorCode);
        };
        /**
         * 背景色に適した文字色を取得する。
         * @param backgroundColor
         */
        A11yColor.getTextColor = function (backgroundColor) {
            var darkRatio = wcagContrast.hex(backgroundColor, this.TEXT_COLOR_BLACK);
            var lightRatio = wcagContrast.hex(backgroundColor, this.TEXT_COLOR_WHITE);
            return lightRatio < darkRatio ? this.TEXT_COLOR_BLACK : this.TEXT_COLOR_WHITE;
        };
        return A11yColor;
    }());
    A11yColor.COLOR_CODE_PATTERN = /^#([A-Fa-f0-9]{6}|[A-Fa-f0-9]{3})$/i;
    A11yColor.TEXT_COLOR_BLACK = '#000000';
    A11yColor.TEXT_COLOR_WHITE = '#FFFFFF';

    var NgbMaterialDatepickerPresenterService = /** @class */ (function () {
        function NgbMaterialDatepickerPresenterService() {
        }
        /**
         * 日付の背景色を初期化する
         * @param dateColor
         */
        NgbMaterialDatepickerPresenterService.prototype.initializeDateColor = function (dateColor) {
            if (dateColor == null) {
                return '#689F37';
            }
            if (!A11yColor.validColorCode(dateColor)) {
                return '#689F37';
            }
            return dateColor;
        };
        /**
         * ヘッダー の背景色を初期化する
         * @param headerColor
         */
        NgbMaterialDatepickerPresenterService.prototype.initializeHeaderColor = function (headerColor) {
            if (headerColor == null) {
                return '#8CC24A';
            }
            if (!A11yColor.validColorCode(headerColor)) {
                return '#8CC24A';
            }
            return headerColor;
        };
        /**
         * 文字色を取得する。文字色が指定されていない場合は、背景色とのコントラスト比から適切な文字色を取得する。
         * @param backgroundColor
         * @param textColor
         */
        NgbMaterialDatepickerPresenterService.prototype.getTextColor = function (backgroundColor, textColor) {
            if (textColor == null) {
                return A11yColor.getTextColor(backgroundColor);
            }
            if (!A11yColor.validColorCode(textColor)) {
                throw new Error('Background Color is invalid.');
            }
            return textColor;
        };
        return NgbMaterialDatepickerPresenterService;
    }());
    NgbMaterialDatepickerPresenterService.ɵprov = i0.ɵɵdefineInjectable({ factory: function NgbMaterialDatepickerPresenterService_Factory() { return new NgbMaterialDatepickerPresenterService(); }, token: NgbMaterialDatepickerPresenterService, providedIn: "root" });
    NgbMaterialDatepickerPresenterService.decorators = [
        { type: i0.Injectable, args: [{
                    providedIn: 'root',
                },] }
    ];
    NgbMaterialDatepickerPresenterService.ctorParameters = function () { return []; };

    var DateService = /** @class */ (function () {
        function DateService() {
        }
        /**
         * 日付を2桁の0埋めする。
         * @param date
         */
        DateService.prototype.fillWithZeros = function (date) {
            var dateString = '' + date;
            return dateString.padStart(2, '0');
        };
        /**
         * 曜日エイリアスを取得する。
         * @param date
         */
        DateService.prototype.getDay = function (date) {
            var day = this._getYearMonthDateDay(date).day;
            return day;
        };
        /**
         * 年月日, 曜日を取得する。
         * @param {undefined|Date} date
         * @return {YearMonthDateDay}
         */
        DateService.prototype.getYearMonthDateDay = function (date) {
            if (date == null) {
                return this._getYearMonthDateDay(new Date());
            }
            return this._getYearMonthDateDay(date);
        };
        /**
         * 年月日からDateオブジェクトを作成する。
         * @param source
         */
        DateService.prototype.getDateFromYearMonthDate = function (source) {
            var year = source.year, zeroBeginningMonth = source.month, date = source.date;
            return new Date(year, zeroBeginningMonth, date);
        };
        /**
         * 月を0始まりの形式に変換する。
         * ※1月であれば0, 12月であれば11に変換する。
         * @param month
         */
        DateService.prototype.convertMonthToZeroStart = function (month) {
            if (month === 0) {
                return 1;
            }
            if (month === 12) {
                return 11;
            }
            return month - 1;
        };
        /**
         * 年月日を指定された形式の日付文字列にする。
         * @param dateFormat
         * @param source
         */
        DateService.prototype.format = function (dateFormat, source) {
            var year = source.year, zeroBeginningMonth = source.month, date = source.date;
            if (year == null || zeroBeginningMonth == null || date == null) {
                throw new Error('Source value is null.');
            }
            return dateFns.format(new Date(year, zeroBeginningMonth, date), dateFormat);
        };
        /**
         * 年月日, 曜日を取得する。
         * @param {Date} sourceDate
         * @private
         * @return {YearMonthDateDay}
         */
        DateService.prototype._getYearMonthDateDay = function (sourceDate) {
            var year = dateFns.getYear(sourceDate);
            // 月は0から始まるため
            var month = dateFns.getMonth(sourceDate) + 1;
            var date = dateFns.getDate(sourceDate);
            var day = dateFns.getDay(sourceDate);
            return { year: year, month: month, date: date, day: day };
        };
        return DateService;
    }());
    DateService.ɵprov = i0.ɵɵdefineInjectable({ factory: function DateService_Factory() { return new DateService(); }, token: DateService, providedIn: "root" });
    DateService.decorators = [
        { type: i0.Injectable, args: [{
                    providedIn: 'root',
                },] }
    ];
    DateService.ctorParameters = function () { return []; };

    var DEFAULT_VALUE = {
        year: 0,
        month: 0,
        date: 0,
        day: 0,
    };
    var DateState = /** @class */ (function () {
        function DateState(_date) {
            this._date = _date;
            this._dateState = new rxjs.BehaviorSubject(DEFAULT_VALUE);
            this.dateState$ = this._dateState.asObservable();
        }
        Object.defineProperty(DateState.prototype, "currentValue", {
            /**
             * 現在の値を取得する。
             */
            get: function () {
                var currentValue = this._dateState.getValue();
                if (currentValue == null) {
                    throw new Error('DateState currentValue is null.');
                }
                return currentValue;
            },
            enumerable: false,
            configurable: true
        });
        /**
         * 現在の日付状態から日付文字列を取得する。
         * @param dateFormat
         */
        DateState.prototype.getDateStringFromCurrentState = function (dateFormat) {
            if (dateFormat === void 0) { dateFormat = 'yyyy-MM-dd HH:mm:ss'; }
            var _a = this.currentValue, year = _a.year, month = _a.month, date = _a.date;
            var monthBeginningZero = this._date.convertMonthToZeroStart(month);
            return this._date.format(dateFormat, { year: year, month: monthBeginningZero, date: date });
        };
        /**
         * DateStateを更新する。
         * @param updateValue
         */
        DateState.prototype.update = function (updateValue) {
            var currentValue = this.currentValue;
            this._dateState.next(Object.assign(Object.assign({}, currentValue), updateValue));
        };
        return DateState;
    }());
    DateState.ɵprov = i0.ɵɵdefineInjectable({ factory: function DateState_Factory() { return new DateState(i0.ɵɵinject(DateService)); }, token: DateState, providedIn: "root" });
    DateState.decorators = [
        { type: i0.Injectable, args: [{
                    providedIn: 'root',
                },] }
    ];
    DateState.ctorParameters = function () { return [
        { type: DateService }
    ]; };

    var NgbMaterialDatepickerComponent = /** @class */ (function () {
        function NgbMaterialDatepickerComponent(_ngbDatepickerService, _presenter, _dataTable, _date, _dateState, _config, _datepickerRef) {
            this._ngbDatepickerService = _ngbDatepickerService;
            this._presenter = _presenter;
            this._dataTable = _dataTable;
            this._date = _date;
            this._dateState = _dateState;
            this._config = _config;
            this._datepickerRef = _datepickerRef;
            this.displayWeek = ['日', '月', '火', '水', '木', '金', '土'];
            this.dateState$ = this._dateState.dateState$;
            this.dataTable = [];
            this.headerColor = '';
            this.dateColor = '';
            this.headerTextColor = '';
            this.dateTextColor = '';
        }
        NgbMaterialDatepickerComponent.prototype.ngOnInit = function () {
            var _a = this._config, headerColor = _a.headerColor, dateColor = _a.dateColor, headerTextColor = _a.headerTextColor, dateTextColor = _a.dateTextColor, initializeValue = _a.initializeValue;
            // 各Styleを設定
            this.headerColor = this._presenter.initializeHeaderColor(headerColor);
            this.dateColor = this._presenter.initializeDateColor(dateColor);
            this.headerTextColor = this._presenter.getTextColor(this.headerColor, headerTextColor);
            this.dateTextColor = this._presenter.getTextColor(this.dateColor, dateTextColor);
            // 日付テーブルを作成する。
            this.dataTable = this._dataTable.create(initializeValue);
            // 初期値を設定する。
            var initializeDate = this._date.getYearMonthDateDay(initializeValue);
            this._dateState.update(initializeDate);
        };
        /**
         * 閉じるがクリックされた。
         */
        NgbMaterialDatepickerComponent.prototype.clickClose = function () {
            this._datepickerRef.close();
        };
        /**
         * OKがクリックされた。
         */
        NgbMaterialDatepickerComponent.prototype.clickOk = function () {
            var outputFormat = this._config.outputFormat;
            var result = this._dateState.getDateStringFromCurrentState(outputFormat);
            this._datepickerRef.close(result);
        };
        /**
         * Cancelがクリックされた。
         */
        NgbMaterialDatepickerComponent.prototype.clickCancel = function () {
            this._datepickerRef.close();
        };
        /**
         * 日付が選択された。
         * @param date
         */
        NgbMaterialDatepickerComponent.prototype.selectDate = function (date) {
            var _a = this._dateState.currentValue, year = _a.year, month = _a.month;
            var zeroBeginningMonth = this._date.convertMonthToZeroStart(month);
            var day = this._date.getDay(this._date.getDateFromYearMonthDate({ year: year, month: zeroBeginningMonth, date: date }));
            this._dateState.update({ date: date, day: day });
        };
        /**
         * 前月を表示する。
         * @param month
         */
        NgbMaterialDatepickerComponent.prototype.lastMonth = function (month) {
            var updateMonth = month !== 1 ? month - 1 : 12;
            this._dateState.update({ month: updateMonth });
            this._updateDateTable();
        };
        /**
         * 次月を表示する。
         * @param month
         */
        NgbMaterialDatepickerComponent.prototype.nextMonth = function (month) {
            var updateMonth = month !== 12 ? month + 1 : 1;
            this._dateState.update({ month: updateMonth });
            this._updateDateTable();
        };
        /**
         * 翌年を表示する。
         * @param year
         */
        NgbMaterialDatepickerComponent.prototype.lastYear = function (year) {
            this._dateState.update({ year: year - 1 });
            this._updateDateTable();
        };
        /**
         * 去年を表示する。
         * @param year
         */
        NgbMaterialDatepickerComponent.prototype.nextYear = function (year) {
            this._dateState.update({ year: year + 1 });
            this._updateDateTable();
        };
        /**
         * DateTableを更新する。
         * @private
         */
        NgbMaterialDatepickerComponent.prototype._updateDateTable = function () {
            var _a = this._dateState.currentValue, year = _a.year, month = _a.month, date = _a.date;
            var convertMonthToZeroStart = this._date.convertMonthToZeroStart(month);
            var yearMonthDate = this._date.getDateFromYearMonthDate({
                year: year,
                month: convertMonthToZeroStart,
                date: date,
            });
            this.dataTable = this._dataTable.create(yearMonthDate);
        };
        return NgbMaterialDatepickerComponent;
    }());
    NgbMaterialDatepickerComponent.decorators = [
        { type: i0.Component, args: [{
                    selector: 'lib-ngb-material-datepicker',
                    template: "<ng-container *ngIf=\"dateState$ | async as dateState\">\n    <lib-header\n        class=\"header\"\n        [days]=\"dateState.day\"\n        [backgroundColor]=\"headerColor\"\n        [textColor]=\"headerTextColor\"\n        (onClickClose)=\"clickClose()\"\n    ></lib-header>\n\n    <lib-year-month-date-area\n        class=\"year-month-date-area\"\n        [backgroundColor]=\"dateColor\"\n        [textColor]=\"dateTextColor\"\n        [selectedYear]=\"dateState.year\"\n        [selectedMonth]=\"dateState.month\"\n        [selectedDate]=\"dateState.date\"\n        (onLastMonth)=\"lastMonth($event)\"\n        (onNextMonth)=\"nextMonth($event)\"\n        (onLastYear)=\"lastYear($event)\"\n        (onNextYear)=\"nextYear($event)\"\n    ></lib-year-month-date-area>\n\n    <lib-calendar\n        class=\"calendar\"\n        [selectedBackgroundColor]=\"dateColor\"\n        [selectedTextColor]=\"dateTextColor\"\n        [displayWeek]=\"displayWeek\"\n        [selectedYear]=\"dateState.year\"\n        [selectedMonth]=\"dateState.month\"\n        [selectedDate]=\"dateState.date\"\n        [dateTable]=\"dataTable\"\n        (onSelectDate)=\"selectDate($event)\"\n    ></lib-calendar>\n\n    <lib-footer class=\"footer\" (onClickOk)=\"clickOk()\" (onClickCancel)=\"clickCancel()\"></lib-footer>\n</ng-container>\n",
                    styles: [""]
                },] }
    ];
    NgbMaterialDatepickerComponent.ctorParameters = function () { return [
        { type: NgbMaterialDatepickerService },
        { type: NgbMaterialDatepickerPresenterService },
        { type: DateTableService },
        { type: DateService },
        { type: DateState },
        { type: NgbMaterialDatepickerConfig },
        { type: NgbMaterialDatepickerRef }
    ]; };

    var HeaderComponent = /** @class */ (function () {
        function HeaderComponent() {
            this.days = 0;
            this.backgroundColor = '#689F37';
            this.textColor = '#FFFFFF';
            this.onClickClose = new i0.EventEmitter();
            this.colorStyle = {
                'background-color': this.backgroundColor,
                color: this.textColor,
            };
        }
        HeaderComponent.prototype.ngOnInit = function () {
            this.colorStyle = {
                'background-color': this.backgroundColor,
                color: this.textColor,
            };
        };
        HeaderComponent.prototype.clickClose = function () {
            this.onClickClose.emit();
        };
        return HeaderComponent;
    }());
    HeaderComponent.decorators = [
        { type: i0.Component, args: [{
                    selector: 'lib-header',
                    template: "<header class=\"header\" [ngStyle]=\"colorStyle\">\n    <div class=\"header__days\">{{ days | convertWeekAlias }}</div>\n    <div class=\"header__close\" (click)=\"clickClose()\">\n        <mat-icon>close</mat-icon>\n    </div>\n</header>\n",
                    styles: [":host{display:block}:host .header{position:relative;padding:.2rem 0;text-align:center}:host .header .header__days{width:100%}:host .header .header__close{position:absolute;top:.05rem;right:.25rem;cursor:default;height:24px}"]
                },] }
    ];
    HeaderComponent.ctorParameters = function () { return []; };
    HeaderComponent.propDecorators = {
        days: [{ type: i0.Input }],
        backgroundColor: [{ type: i0.Input }],
        textColor: [{ type: i0.Input }],
        onClickClose: [{ type: i0.Output }]
    };

    var YearMonthDateAreaComponent = /** @class */ (function () {
        function YearMonthDateAreaComponent() {
            this.selectedMonth = 0;
            this.selectedDate = 0;
            this.selectedYear = 0;
            this.backgroundColor = '#8CC24A';
            this.textColor = '#FFFFFF';
            this.onLastMonth = new i0.EventEmitter();
            this.onNextMonth = new i0.EventEmitter();
            this.onLastYear = new i0.EventEmitter();
            this.onNextYear = new i0.EventEmitter();
            this.colorStyle = {
                'background-color': this.backgroundColor,
                color: this.textColor,
            };
        }
        YearMonthDateAreaComponent.prototype.ngOnInit = function () {
            this.colorStyle = {
                'background-color': this.backgroundColor,
                color: this.textColor,
            };
        };
        YearMonthDateAreaComponent.prototype.lastMonth = function (month) {
            this.onLastMonth.emit(month);
        };
        YearMonthDateAreaComponent.prototype.nextMonth = function (month) {
            this.onNextMonth.emit(month);
        };
        YearMonthDateAreaComponent.prototype.lastYear = function (year) {
            this.onLastYear.emit(year);
        };
        YearMonthDateAreaComponent.prototype.nextYear = function (year) {
            this.onNextYear.emit(year);
        };
        return YearMonthDateAreaComponent;
    }());
    YearMonthDateAreaComponent.decorators = [
        { type: i0.Component, args: [{
                    selector: 'lib-year-month-date-area',
                    template: "<div class=\"year-month-date-area\" [ngStyle]=\"colorStyle\">\n    <lib-select-month\n        [month]=\"selectedMonth\"\n        (onClickLastMonth)=\"lastMonth($event)\"\n        (onClickNextMonth)=\"nextMonth($event)\"\n    ></lib-select-month>\n    <lib-select-date>{{ selectedDate | fillDateWithZeros }}</lib-select-date>\n    <lib-select-year\n        [year]=\"selectedYear\"\n        (onClickLastYear)=\"lastYear($event)\"\n        (onClickNextYear)=\"nextYear($event)\"\n    ></lib-select-year>\n</div>\n",
                    styles: [":host{display:block}:host .year-month-date-area{padding:.4rem 1rem}"]
                },] }
    ];
    YearMonthDateAreaComponent.ctorParameters = function () { return []; };
    YearMonthDateAreaComponent.propDecorators = {
        selectedMonth: [{ type: i0.Input }],
        selectedDate: [{ type: i0.Input }],
        selectedYear: [{ type: i0.Input }],
        backgroundColor: [{ type: i0.Input }],
        textColor: [{ type: i0.Input }],
        onLastMonth: [{ type: i0.Output }],
        onNextMonth: [{ type: i0.Output }],
        onLastYear: [{ type: i0.Output }],
        onNextYear: [{ type: i0.Output }]
    };

    var SelectMonthComponent = /** @class */ (function () {
        function SelectMonthComponent() {
            this.month = 0;
            this.onClickLastMonth = new i0.EventEmitter();
            this.onClickNextMonth = new i0.EventEmitter();
        }
        SelectMonthComponent.prototype.ngOnInit = function () { };
        SelectMonthComponent.prototype.lastMonth = function () {
            this.onClickLastMonth.emit(this.month);
        };
        SelectMonthComponent.prototype.nextMonth = function () {
            this.onClickNextMonth.emit(this.month);
        };
        return SelectMonthComponent;
    }());
    SelectMonthComponent.decorators = [
        { type: i0.Component, args: [{
                    selector: 'lib-select-month',
                    template: "<div class=\"select-month\">\n    <div class=\"select-month__last-month\" (click)=\"lastMonth()\">\n        <mat-icon>chevron_left</mat-icon>\n    </div>\n    <div class=\"select-month__current-month\">{{ month }}\u6708</div>\n    <div class=\"select-month__next-month\" (click)=\"nextMonth()\">\n        <mat-icon>chevron_right</mat-icon>\n    </div>\n</div>\n",
                    styles: [":host{display:block}:host .select-month{display:flex;justify-content:space-between;align-items:center}:host .select-month .select-month__last-month{height:24px;cursor:default}:host .select-month .select-month__current-month{font-size:1.25rem}:host .select-month .select-month__next-month{height:24px;cursor:default}"]
                },] }
    ];
    SelectMonthComponent.ctorParameters = function () { return []; };
    SelectMonthComponent.propDecorators = {
        month: [{ type: i0.Input }],
        onClickLastMonth: [{ type: i0.Output }],
        onClickNextMonth: [{ type: i0.Output }]
    };

    var SelectYearComponent = /** @class */ (function () {
        function SelectYearComponent() {
            this.year = 0;
            this.onClickLastYear = new i0.EventEmitter();
            this.onClickNextYear = new i0.EventEmitter();
        }
        SelectYearComponent.prototype.ngOnInit = function () { };
        SelectYearComponent.prototype.lastYear = function () {
            this.onClickLastYear.emit(this.year);
        };
        SelectYearComponent.prototype.nextYear = function () {
            this.onClickNextYear.emit(this.year);
        };
        return SelectYearComponent;
    }());
    SelectYearComponent.decorators = [
        { type: i0.Component, args: [{
                    selector: 'lib-select-year',
                    template: "<div class=\"select-year\">\n    <div class=\"select-year__last-year\" (click)=\"lastYear()\">\n        <mat-icon>chevron_left</mat-icon>\n    </div>\n    <div class=\"select-year__current-year\">{{ year }}</div>\n    <div class=\"select-year__next-year\" (click)=\"nextYear()\">\n        <mat-icon>chevron_right</mat-icon>\n    </div>\n</div>\n",
                    styles: [":host{display:block}:host .select-year{display:flex;justify-content:space-between;align-items:center}:host .select-year .select-year__last-year{height:24px;cursor:default}:host .select-year .select-year__current-year{font-size:1.25rem}:host .select-year .select-year__next-year{height:24px;cursor:default}"]
                },] }
    ];
    SelectYearComponent.ctorParameters = function () { return []; };
    SelectYearComponent.propDecorators = {
        year: [{ type: i0.Input }],
        onClickLastYear: [{ type: i0.Output }],
        onClickNextYear: [{ type: i0.Output }]
    };

    var SelectDateComponent = /** @class */ (function () {
        function SelectDateComponent() {
        }
        SelectDateComponent.prototype.ngOnInit = function () { };
        return SelectDateComponent;
    }());
    SelectDateComponent.decorators = [
        { type: i0.Component, args: [{
                    selector: 'lib-select-date',
                    template: "<ng-content></ng-content>",
                    styles: ["\n            :host {\n                display: flex;\n                justify-content: center;\n                align-items: center;\n                font-size: 45px;\n                height: 45px;\n            }\n        "]
                },] }
    ];
    SelectDateComponent.ctorParameters = function () { return []; };

    var DateTableComponent = /** @class */ (function () {
        function DateTableComponent(thisEleRef) {
            this.thisEleRef = thisEleRef;
            this.displayWeek = ['', '', '', '', '', '', ''];
            this.dateTable = [];
            this.selectedDate = 0;
            this.selectedBackgroundColor = '#8cc24a';
            this.selectedTextColor = '#FFFFFF';
            this.onSelectDate = new i0.EventEmitter();
        }
        DateTableComponent.prototype.ngAfterContentInit = function () {
            this.updateSelectedColor();
        };
        DateTableComponent.prototype.selectDate = function (date) {
            this.onSelectDate.emit(date);
        };
        DateTableComponent.prototype.updateSelectedColor = function () {
            this.thisEleRef.nativeElement.style.setProperty('--selected-background-color', this.selectedBackgroundColor);
            this.thisEleRef.nativeElement.style.setProperty('--selected-color', this.selectedTextColor);
        };
        return DateTableComponent;
    }());
    DateTableComponent.decorators = [
        { type: i0.Component, args: [{
                    selector: 'lib-date-table',
                    template: "<div class=\"week\" *ngFor=\"let week of dateTable\">\n    <div class=\"week__date-wrapper\" *ngFor=\"let date of week\">\n        <div\n            class=\"week__date\"\n            [ngClass]=\"{ selected: date | isSelectedDate: selectedDate }\"\n            (click)=\"selectDate(date)\"\n        >\n            {{ date | fillDateWithZeros }}\n        </div>\n    </div>\n</div>\n",
                    styles: [":host{display:block;--selected-background-color:#8cc24a;--selected-color:#fff}:host .selected{background-color:var(--selected-background-color);color:var(--selected-color);border-radius:50%}:host .week{display:flex}:host .week .week__date-wrapper{width:calc(100% / 7);padding:.3rem}:host .week .week__date{text-align:center;line-height:1.85rem;cursor:default}"]
                },] }
    ];
    DateTableComponent.ctorParameters = function () { return [
        { type: i0.ElementRef }
    ]; };
    DateTableComponent.propDecorators = {
        displayWeek: [{ type: i0.Input }],
        dateTable: [{ type: i0.Input }],
        selectedDate: [{ type: i0.Input }],
        selectedBackgroundColor: [{ type: i0.Input }],
        selectedTextColor: [{ type: i0.Input }],
        onSelectDate: [{ type: i0.Output }]
    };

    var CalendarComponent = /** @class */ (function () {
        function CalendarComponent() {
            this.selectedBackgroundColor = '';
            this.selectedTextColor = '';
            this.selectedDate = 0;
            this.selectedMonth = 0;
            this.selectedYear = 0;
            this.displayWeek = ['', '', '', '', '', '', ''];
            this.dateTable = [];
            this.onSelectDate = new i0.EventEmitter();
        }
        CalendarComponent.prototype.ngOnInit = function () { };
        CalendarComponent.prototype.selectDate = function (date) {
            this.onSelectDate.emit(date);
        };
        return CalendarComponent;
    }());
    CalendarComponent.decorators = [
        { type: i0.Component, args: [{
                    selector: 'lib-calendar',
                    template: "<lib-year-month class=\"year-month\">{{ selectedMonth }}\u6708&nbsp;{{ selectedYear }}</lib-year-month>\n\n<lib-week class=\"week\" [displayWeek]=\"displayWeek\"></lib-week>\n\n<lib-date-table\n    class=\"date-table\"\n    [selectedBackgroundColor]=\"selectedBackgroundColor\"\n    [selectedTextColor]=\"selectedTextColor\"\n    [displayWeek]=\"displayWeek\"\n    [dateTable]=\"dateTable\"\n    [selectedDate]=\"selectedDate\"\n    (onSelectDate)=\"selectDate($event)\"\n></lib-date-table>\n",
                    styles: [":host{display:block;padding:1rem}:host .week{margin-top:1rem}"]
                },] }
    ];
    CalendarComponent.ctorParameters = function () { return []; };
    CalendarComponent.propDecorators = {
        selectedBackgroundColor: [{ type: i0.Input }],
        selectedTextColor: [{ type: i0.Input }],
        selectedDate: [{ type: i0.Input }],
        selectedMonth: [{ type: i0.Input }],
        selectedYear: [{ type: i0.Input }],
        displayWeek: [{ type: i0.Input }],
        dateTable: [{ type: i0.Input }],
        onSelectDate: [{ type: i0.Output }]
    };

    var YearMonthComponent = /** @class */ (function () {
        function YearMonthComponent() {
        }
        YearMonthComponent.prototype.ngOnInit = function () { };
        return YearMonthComponent;
    }());
    YearMonthComponent.decorators = [
        { type: i0.Component, args: [{
                    selector: 'lib-year-month',
                    template: " <ng-content></ng-content> ",
                    styles: ["\n            :host {\n                display: flex;\n                justify-content: center;\n                align-items: center;\n            }\n        "]
                },] }
    ];
    YearMonthComponent.ctorParameters = function () { return []; };

    var WeekComponent = /** @class */ (function () {
        function WeekComponent() {
            this.displayWeek = ['', '', '', '', '', '', ''];
        }
        WeekComponent.prototype.ngOnInit = function () { };
        return WeekComponent;
    }());
    WeekComponent.decorators = [
        { type: i0.Component, args: [{
                    selector: 'lib-week',
                    template: " <span class=\"days\" *ngFor=\"let day of displayWeek\">{{ day }}</span> ",
                    styles: ["\n            :host {\n                display: flex;\n                justify-content: space-between;\n                align-items: center;\n                color: #757575;\n            }\n        ",
                        "\n            .days {\n                width: calc(100% / 7);\n                text-align: center;\n            }\n        "]
                },] }
    ];
    WeekComponent.ctorParameters = function () { return []; };
    WeekComponent.propDecorators = {
        displayWeek: [{ type: i0.Input }]
    };

    var FillDateWithZerosPipe = /** @class */ (function () {
        function FillDateWithZerosPipe(_date) {
            this._date = _date;
        }
        /**
         * 数値の日付を2桁の0埋めをした文字列日付に変換する
         * @param {number} date
         * @return {string}
         */
        FillDateWithZerosPipe.prototype.transform = function (date) {
            if (date === 0) {
                return '';
            }
            return this._date.fillWithZeros(date);
        };
        return FillDateWithZerosPipe;
    }());
    FillDateWithZerosPipe.decorators = [
        { type: i0.Pipe, args: [{
                    name: 'fillDateWithZeros',
                },] }
    ];
    FillDateWithZerosPipe.ctorParameters = function () { return [
        { type: DateService }
    ]; };

    var IsSelectedDatePipe = /** @class */ (function () {
        function IsSelectedDatePipe() {
        }
        /**
         * この日付は選択されている。
         * @param thisDate
         * @param selectedDate
         */
        IsSelectedDatePipe.prototype.transform = function (thisDate, selectedDate) {
            if (thisDate === 0) {
                return false;
            }
            return thisDate === selectedDate;
        };
        return IsSelectedDatePipe;
    }());
    IsSelectedDatePipe.decorators = [
        { type: i0.Pipe, args: [{
                    name: 'isSelectedDate',
                },] }
    ];

    var FooterComponent = /** @class */ (function () {
        function FooterComponent() {
            this.onClickCancel = new i0.EventEmitter();
            this.onClickOk = new i0.EventEmitter();
        }
        FooterComponent.prototype.ngOnInit = function () { };
        FooterComponent.prototype.clickCancel = function () {
            this.onClickCancel.emit();
        };
        FooterComponent.prototype.clickOk = function () {
            this.onClickOk.emit();
        };
        return FooterComponent;
    }());
    FooterComponent.decorators = [
        { type: i0.Component, args: [{
                    selector: 'lib-footer',
                    template: "<button mat-button (click)=\"clickCancel()\">CANCEL</button>\n<button mat-button class=\"ok-button\" (click)=\"clickOk()\">OK</button>\n",
                    styles: [":host{display:flex;justify-content:flex-end;align-items:center;padding:0 1rem}:host .ok-button{margin-left:.5rem}"]
                },] }
    ];
    FooterComponent.ctorParameters = function () { return []; };
    FooterComponent.propDecorators = {
        onClickCancel: [{ type: i0.Output }],
        onClickOk: [{ type: i0.Output }]
    };

    var JapaneseWeek = {
        0: '日曜日',
        1: '月曜日',
        2: '火曜日',
        3: '水曜日',
        4: '木曜日',
        5: '金曜日',
        6: '土曜日',
    };

    var ConvertWeekAliasPipe = /** @class */ (function () {
        function ConvertWeekAliasPipe() {
        }
        /**
         * 曜日エイリアスから日本の曜日を取得する
         * @param weekAlias
         */
        ConvertWeekAliasPipe.prototype.transform = function (weekAlias) {
            return JapaneseWeek[weekAlias];
        };
        return ConvertWeekAliasPipe;
    }());
    ConvertWeekAliasPipe.decorators = [
        { type: i0.Pipe, args: [{
                    name: 'convertWeekAlias',
                },] }
    ];

    var NgbMaterialDatepickerModule = /** @class */ (function () {
        function NgbMaterialDatepickerModule() {
        }
        return NgbMaterialDatepickerModule;
    }());
    NgbMaterialDatepickerModule.decorators = [
        { type: i0.NgModule, args: [{
                    declarations: [
                        NgbMaterialDatepickerComponent,
                        NgbMaterialDatepickerOverlayComponent,
                        HeaderComponent,
                        YearMonthDateAreaComponent,
                        SelectMonthComponent,
                        SelectYearComponent,
                        SelectDateComponent,
                        DateTableComponent,
                        CalendarComponent,
                        YearMonthComponent,
                        WeekComponent,
                        FillDateWithZerosPipe,
                        IsSelectedDatePipe,
                        FooterComponent,
                        ConvertWeekAliasPipe,
                    ],
                    imports: [common.CommonModule, icon.MatIconModule, button.MatButtonModule],
                    exports: [],
                },] }
    ];

    /*
     * Public API Surface of ngb-material-datepicker
     */

    /**
     * Generated bundle index. Do not edit.
     */

    exports.NgbMaterialDatepickerComponent = NgbMaterialDatepickerComponent;
    exports.NgbMaterialDatepickerModule = NgbMaterialDatepickerModule;
    exports.NgbMaterialDatepickerService = NgbMaterialDatepickerService;
    exports.ɵa = DynamicallyComponentService;
    exports.ɵb = NgbMaterialDatepickerPresenterService;
    exports.ɵc = DateTableService;
    exports.ɵd = DateService;
    exports.ɵe = DateState;
    exports.ɵf = NgbMaterialDatepickerConfig;
    exports.ɵg = NgbMaterialDatepickerRef;
    exports.ɵh = NgbMaterialDatepickerOverlayComponent;
    exports.ɵi = HeaderComponent;
    exports.ɵj = YearMonthDateAreaComponent;
    exports.ɵk = SelectMonthComponent;
    exports.ɵl = SelectYearComponent;
    exports.ɵm = SelectDateComponent;
    exports.ɵn = DateTableComponent;
    exports.ɵo = CalendarComponent;
    exports.ɵp = YearMonthComponent;
    exports.ɵq = WeekComponent;
    exports.ɵr = FillDateWithZerosPipe;
    exports.ɵs = IsSelectedDatePipe;
    exports.ɵt = FooterComponent;
    exports.ɵu = ConvertWeekAliasPipe;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ngb-material-datepicker.umd.js.map
