import { YearMonthDate, YearMonthDateDay } from '../types/date';
import { WeekAlias } from '../types/week';
export declare class DateService {
    constructor();
    /**
     * 日付を2桁の0埋めする。
     * @param date
     */
    fillWithZeros(date: number): string;
    /**
     * 曜日エイリアスを取得する。
     * @param date
     */
    getDay(date: Date): WeekAlias;
    /**
     * 年月日, 曜日を取得する。
     * @param {undefined|Date} date
     * @return {YearMonthDateDay}
     */
    getYearMonthDateDay(date?: Date): YearMonthDateDay;
    /**
     * 年月日からDateオブジェクトを作成する。
     * @param source
     */
    getDateFromYearMonthDate(source: YearMonthDate): Date;
    /**
     * 月を0始まりの形式に変換する。
     * ※1月であれば0, 12月であれば11に変換する。
     * @param month
     */
    convertMonthToZeroStart(month: number): number;
    /**
     * 年月日を指定された形式の日付文字列にする。
     * @param dateFormat
     * @param source
     */
    format(dateFormat: string, source: YearMonthDate): string;
    /**
     * 年月日, 曜日を取得する。
     * @param {Date} sourceDate
     * @private
     * @return {YearMonthDateDay}
     */
    private _getYearMonthDateDay;
}
