import { ApplicationRef, ComponentFactoryResolver, ComponentRef, Injector, Type } from '@angular/core';
import { NgbMaterialDatepickerConfig } from '../injector/ngb-material-datepicker-config';
import { NgbMaterialDatepickerRef } from '../ngb-material-datepicker-ref';
export declare class DynamicallyComponentService<ComponentClassType> {
    private componentFactoryResolver;
    private applicationRef;
    private injector;
    private _dynamicComponentRef?;
    constructor(componentFactoryResolver: ComponentFactoryResolver, applicationRef: ApplicationRef, injector: Injector);
    get dynamicComponentRef(): ComponentRef<ComponentClassType>;
    /**
     * 動的コンポーネントをdocument.body配下に追加する。
     */
    appendToApplication(type: Type<ComponentClassType>, config: NgbMaterialDatepickerConfig): NgbMaterialDatepickerRef;
    /**
     * 動的コンポーネントをdocument.bodyから削除する。
     * @private
     */
    private _removeFromApplication;
    /**
     * ComponentRefを作成する。
     * @param componentType
     * @param config
     * @param datepickerRef
     * @private
     * @return {ComponentRef}
     */
    private createComponentRef;
    /**
     * ComponentRefをdocument.body配下に追加する。
     * @param componentRef
     * @private
     * @return {void}
     */
    private _attachComponentToDocumentBody;
}
