import { OnInit } from '@angular/core';
import { Week } from '../types/week';
import { DateTable } from '../types/date-table';
import { DateTableService } from './components/calendar/date-table.service';
import { NgbMaterialDatepickerService } from '../ngb-material-datepicker.service';
import { NgbMaterialDatepickerConfig } from '../injector/ngb-material-datepicker-config';
import { NgbMaterialDatepickerPresenterService } from './ngb-material-datepicker-presenter.service';
import { DateService } from '../libs/date.service';
import { Observable } from 'rxjs';
import { YearMonthDateDay } from '../types/date';
import { DateState } from '../states/date-state';
import { NgbMaterialDatepickerRef } from '../ngb-material-datepicker-ref';
export declare class NgbMaterialDatepickerComponent implements OnInit {
    private _ngbDatepickerService;
    private _presenter;
    private _dataTable;
    private _date;
    private _dateState;
    private _config;
    private _datepickerRef;
    displayWeek: Week;
    dateState$: Observable<YearMonthDateDay>;
    dataTable: DateTable;
    headerColor: string;
    dateColor: string;
    headerTextColor: string;
    dateTextColor: string;
    constructor(_ngbDatepickerService: NgbMaterialDatepickerService, _presenter: NgbMaterialDatepickerPresenterService, _dataTable: DateTableService, _date: DateService, _dateState: DateState, _config: NgbMaterialDatepickerConfig, _datepickerRef: NgbMaterialDatepickerRef);
    ngOnInit(): void;
    /**
     * 閉じるがクリックされた。
     */
    clickClose(): void;
    /**
     * OKがクリックされた。
     */
    clickOk(): void;
    /**
     * Cancelがクリックされた。
     */
    clickCancel(): void;
    /**
     * 日付が選択された。
     * @param date
     */
    selectDate(date: number): void;
    /**
     * 前月を表示する。
     * @param month
     */
    lastMonth(month: number): void;
    /**
     * 次月を表示する。
     * @param month
     */
    nextMonth(month: number): void;
    /**
     * 翌年を表示する。
     * @param year
     */
    lastYear(year: number): void;
    /**
     * 去年を表示する。
     * @param year
     */
    nextYear(year: number): void;
    /**
     * DateTableを更新する。
     * @private
     */
    private _updateDateTable;
}
