import { YearMonthDateDay } from '../types/date';
import { Observable } from 'rxjs';
import { WeekAlias } from '../types/week';
import { DateService } from '../libs/date.service';
export declare type UpdateDateState = {
    year?: number;
    month?: number;
    date?: number;
    day?: WeekAlias;
};
export declare class DateState {
    private _date;
    private _dateState;
    dateState$: Observable<YearMonthDateDay>;
    constructor(_date: DateService);
    /**
     * 現在の値を取得する。
     */
    get currentValue(): YearMonthDateDay;
    /**
     * 現在の日付状態から日付文字列を取得する。
     * @param dateFormat
     */
    getDateStringFromCurrentState(dateFormat?: string): string;
    /**
     * DateStateを更新する。
     * @param updateValue
     */
    update(updateValue: UpdateDateState): void;
}
